package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import org.antlr.codegen.CodeGenerator;
import org.antlr.grammar.v3.ANTLRTreePrinter;
import org.antlr.grammar.v3.LeftRecursiveRuleWalker;
import org.antlr.runtime.Token;
import org.antlr.runtime.tree.CommonTreeNodeStream;
import org.antlr.runtime.tree.TreeNodeStream;
import org.antlr.tool.AttributeScope;
import org.antlr.tool.ErrorManager;
import org.antlr.tool.Grammar;
import org.antlr.tool.GrammarAST;
import org.antlr.tool.ToolSTGroupFile;
import org.stringtemplate.v4.ST;
import org.stringtemplate.v4.STGroup;

public class LeftRecursiveRuleAnalyzer extends LeftRecursiveRuleWalker {
  public Grammar g;
  
  public CodeGenerator generator;
  
  public String ruleName;
  
  Map<Integer, Integer> tokenToPrec = new HashMap<Integer, Integer>();
  
  public LinkedHashMap<Integer, String> binaryAlts = new LinkedHashMap<Integer, String>();
  
  public LinkedHashMap<Integer, String> ternaryAlts = new LinkedHashMap<Integer, String>();
  
  public LinkedHashMap<Integer, String> suffixAlts = new LinkedHashMap<Integer, String>();
  
  public List<String> prefixAlts = new ArrayList<String>();
  
  public List<String> otherAlts = new ArrayList<String>();
  
  public GrammarAST retvals;
  
  public STGroup recRuleTemplates;
  
  public String language;
  
  public Map<Integer, ASSOC> altAssociativity = new HashMap<Integer, ASSOC>();
  
  public LeftRecursiveRuleAnalyzer(TreeNodeStream input, Grammar g, String ruleName) {
    super(input);
    this.g = g;
    this.ruleName = ruleName;
    this.language = (String)g.getOption("language");
    this.generator = new CodeGenerator(g.tool, g, this.language);
    this.generator.loadTemplates(this.language);
    loadPrecRuleTemplates();
  }
  
  public void loadPrecRuleTemplates() {
    this.recRuleTemplates = new ToolSTGroupFile(CodeGenerator.classpathTemplateRootDirectoryName + "/LeftRecursiveRules.stg");
    if (!this.recRuleTemplates.isDefined("recRuleName")) {
      ErrorManager.error(20, "PrecRules");
      return;
    } 
  }
  
  public void setReturnValues(GrammarAST t) {
    System.out.println(t);
    this.retvals = t;
  }
  
  public void setTokenPrec(GrammarAST t, int alt) {
    int ttype = this.g.getTokenType(t.getText());
    this.tokenToPrec.put(Integer.valueOf(ttype), Integer.valueOf(alt));
    ASSOC assoc = ASSOC.left;
    if (t.terminalOptions != null) {
      String a = (String)t.terminalOptions.get("assoc");
      if (a != null)
        if (a.equals(ASSOC.right.toString())) {
          assoc = ASSOC.right;
        } else {
          ErrorManager.error(168, "assoc", assoc);
        }  
    } 
    if (this.altAssociativity.get(Integer.valueOf(alt)) != null && this.altAssociativity.get(Integer.valueOf(alt)) != assoc)
      ErrorManager.error(169, Integer.valueOf(alt)); 
    this.altAssociativity.put(Integer.valueOf(alt), assoc);
  }
  
  public void binaryAlt(GrammarAST altTree, GrammarAST rewriteTree, int alt) {
    altTree = GrammarAST.dupTree(altTree);
    rewriteTree = GrammarAST.dupTree(rewriteTree);
    stripSynPred(altTree);
    stripLeftRecursion(altTree);
    int nextPrec = nextPrecedence(alt);
    ST refST = this.recRuleTemplates.getInstanceOf("recRuleRef");
    refST.add("ruleName", this.ruleName);
    refST.add("arg", Integer.valueOf(nextPrec));
    altTree = replaceRuleRefs(altTree, refST.render());
    String altText = text(altTree);
    altText = altText.trim();
    altText = altText + "{}";
    ST nameST = this.recRuleTemplates.getInstanceOf("recRuleName");
    nameST.add("ruleName", this.ruleName);
    rewriteTree = replaceRuleRefs(rewriteTree, "$" + nameST.render());
    String rewriteText = text(rewriteTree);
    this.binaryAlts.put(Integer.valueOf(alt), altText + ((rewriteText != null) ? (" " + rewriteText) : ""));
  }
  
  public void ternaryAlt(GrammarAST altTree, GrammarAST rewriteTree, int alt) {
    altTree = GrammarAST.dupTree(altTree);
    rewriteTree = GrammarAST.dupTree(rewriteTree);
    stripSynPred(altTree);
    stripLeftRecursion(altTree);
    int nextPrec = nextPrecedence(alt);
    ST refST = this.recRuleTemplates.getInstanceOf("recRuleRef");
    refST.add("ruleName", this.ruleName);
    refST.add("arg", Integer.valueOf(nextPrec));
    altTree = replaceLastRuleRef(altTree, refST.render());
    String altText = text(altTree);
    altText = altText.trim();
    altText = altText + "{}";
    ST nameST = this.recRuleTemplates.getInstanceOf("recRuleName");
    nameST.add("ruleName", this.ruleName);
    rewriteTree = replaceRuleRefs(rewriteTree, "$" + nameST.render());
    String rewriteText = text(rewriteTree);
    this.ternaryAlts.put(Integer.valueOf(alt), altText + ((rewriteText != null) ? (" " + rewriteText) : ""));
  }
  
  public void prefixAlt(GrammarAST altTree, GrammarAST rewriteTree, int alt) {
    altTree = GrammarAST.dupTree(altTree);
    rewriteTree = GrammarAST.dupTree(rewriteTree);
    stripSynPred(altTree);
    int nextPrec = precedence(alt);
    ST refST = this.recRuleTemplates.getInstanceOf("recRuleRef");
    refST.add("ruleName", this.ruleName);
    refST.add("arg", Integer.valueOf(nextPrec));
    altTree = replaceRuleRefs(altTree, refST.render());
    String altText = text(altTree);
    altText = altText.trim();
    altText = altText + "{}";
    ST nameST = this.recRuleTemplates.getInstanceOf("recRuleName");
    nameST.add("ruleName", this.ruleName);
    rewriteTree = replaceRuleRefs(rewriteTree, nameST.render());
    String rewriteText = text(rewriteTree);
    this.prefixAlts.add(altText + ((rewriteText != null) ? (" " + rewriteText) : ""));
  }
  
  public void suffixAlt(GrammarAST altTree, GrammarAST rewriteTree, int alt) {
    altTree = GrammarAST.dupTree(altTree);
    rewriteTree = GrammarAST.dupTree(rewriteTree);
    stripSynPred(altTree);
    stripLeftRecursion(altTree);
    ST nameST = this.recRuleTemplates.getInstanceOf("recRuleName");
    nameST.add("ruleName", this.ruleName);
    rewriteTree = replaceRuleRefs(rewriteTree, "$" + nameST.render());
    String rewriteText = text(rewriteTree);
    String altText = text(altTree);
    altText = altText.trim();
    this.suffixAlts.put(Integer.valueOf(alt), altText + ((rewriteText != null) ? (" " + rewriteText) : ""));
  }
  
  public void otherAlt(GrammarAST altTree, GrammarAST rewriteTree, int alt) {
    altTree = GrammarAST.dupTree(altTree);
    rewriteTree = GrammarAST.dupTree(rewriteTree);
    stripSynPred(altTree);
    stripLeftRecursion(altTree);
    String altText = text(altTree);
    String rewriteText = text(rewriteTree);
    this.otherAlts.add(altText + ((rewriteText != null) ? (" " + rewriteText) : ""));
  }
  
  public String getArtificialPrecStartRule() {
    ST ruleST = this.recRuleTemplates.getInstanceOf("recRuleStart");
    ruleST.add("ruleName", this.ruleName);
    ruleST.add("minPrec", Integer.valueOf(0));
    ruleST.add("userRetvals", this.retvals);
    fillRetValAssignments(ruleST, "recRuleName");
    System.out.println("start: " + ruleST);
    return ruleST.render();
  }
  
  public String getArtificialOpPrecRule() {
    ST ruleST = this.recRuleTemplates.getInstanceOf("recRule");
    ruleST.add("ruleName", this.ruleName);
    ruleST.add("buildAST", Boolean.valueOf(this.grammar.buildAST()));
    ST argDefST = this.generator.getTemplates().getInstanceOf("recRuleDefArg");
    ruleST.add("precArgDef", argDefST);
    ST ruleArgST = this.generator.getTemplates().getInstanceOf("recRuleArg");
    ruleST.add("argName", ruleArgST);
    ST setResultST = this.generator.getTemplates().getInstanceOf("recRuleSetResultAction");
    ruleST.add("setResultAction", setResultST);
    ruleST.add("userRetvals", this.retvals);
    fillRetValAssignments(ruleST, "recPrimaryName");
    LinkedHashMap<Integer, String> opPrecRuleAlts = new LinkedHashMap<Integer, String>();
    opPrecRuleAlts.putAll(this.binaryAlts);
    opPrecRuleAlts.putAll(this.ternaryAlts);
    opPrecRuleAlts.putAll(this.suffixAlts);
    for (Map.Entry<Integer, String> entry : opPrecRuleAlts.entrySet()) {
      int alt = ((Integer)entry.getKey()).intValue();
      String altText = entry.getValue();
      ST altST = this.recRuleTemplates.getInstanceOf("recRuleAlt");
      ST predST = this.generator.getTemplates().getInstanceOf("recRuleAltPredicate");
      predST.add("opPrec", Integer.valueOf(precedence(alt)));
      predST.add("ruleName", this.ruleName);
      altST.add("pred", predST);
      altST.add("alt", altText);
      ruleST.add("alts", altST);
    } 
    System.out.println(ruleST);
    return ruleST.render();
  }
  
  public String getArtificialPrimaryRule() {
    ST ruleST = this.recRuleTemplates.getInstanceOf("recPrimaryRule");
    ruleST.add("ruleName", this.ruleName);
    ruleST.add("alts", this.prefixAlts);
    ruleST.add("alts", this.otherAlts);
    ruleST.add("userRetvals", this.retvals);
    System.out.println(ruleST);
    return ruleST.render();
  }
  
  public GrammarAST replaceRuleRefs(GrammarAST t, String name) {
    if (t == null)
      return null; 
    for (GrammarAST rref : t.findAllType(80)) {
      if (rref.getText().equals(this.ruleName))
        rref.setText(name); 
    } 
    return t;
  }
  
  public static boolean hasImmediateRecursiveRuleRefs(GrammarAST t, String ruleName) {
    if (t == null)
      return false; 
    for (GrammarAST rref : t.findAllType(80)) {
      if (rref.getText().equals(ruleName))
        return true; 
    } 
    return false;
  }
  
  public GrammarAST replaceLastRuleRef(GrammarAST t, String name) {
    if (t == null)
      return null; 
    GrammarAST last = null;
    for (Iterator<GrammarAST> i$ = t.findAllType(80).iterator(); i$.hasNext(); last = rref = i$.next());
    if (last != null && last.getText().equals(this.ruleName))
      last.setText(name); 
    return t;
  }
  
  public void stripSynPred(GrammarAST altAST) {
    GrammarAST t = (GrammarAST)altAST.getChild(0);
    if (t.getType() == 14 || t.getType() == 89 || t.getType() == 90)
      altAST.deleteChild(0); 
  }
  
  public void stripLeftRecursion(GrammarAST altAST) {
    GrammarAST rref = (GrammarAST)altAST.getChild(0);
    if (rref.getType() == 80 && rref.getText().equals(this.ruleName)) {
      altAST.deleteChild(0);
      GrammarAST newFirstChild = (GrammarAST)altAST.getChild(0);
      altAST.setTokenStartIndex(newFirstChild.getTokenStartIndex());
    } 
  }
  
  public String text(GrammarAST t) {
    if (t == null)
      return null; 
    try {
      return (new ANTLRTreePrinter(new CommonTreeNodeStream(t))).toString(this.grammar, true);
    } catch (Exception e) {
      ErrorManager.error(15, e);
      return null;
    } 
  }
  
  public int precedence(int alt) {
    return this.numAlts - alt + 1;
  }
  
  public int nextPrecedence(int alt) {
    int p = precedence(alt);
    if (this.altAssociativity.get(Integer.valueOf(alt)) == ASSOC.left)
      p++; 
    return p;
  }
  
  public void fillRetValAssignments(ST ruleST, String srcName) {
    if (this.retvals == null)
      return; 
    for (String name : getNamesFromArgAction(this.retvals.token)) {
      ST setRetValST = this.generator.getTemplates().getInstanceOf("recRuleSetReturnAction");
      ST ruleNameST = this.recRuleTemplates.getInstanceOf(srcName);
      ruleNameST.add("ruleName", this.ruleName);
      setRetValST.add("src", ruleNameST);
      setRetValST.add("name", name);
      ruleST.add("userRetvalAssignments", setRetValST);
    } 
  }
  
  public Collection<String> getNamesFromArgAction(Token t) {
    AttributeScope returnScope = this.grammar.createReturnScope("", t);
    returnScope.addAttributes(t.getText(), 44);
    return returnScope.attributes.keySet();
  }
  
  public String toString() {
    return "PrecRuleOperatorCollector{binaryAlts=" + this.binaryAlts + ", rec=" + this.tokenToPrec + ", ternaryAlts=" + this.ternaryAlts + ", suffixAlts=" + this.suffixAlts + ", prefixAlts=" + this.prefixAlts + ", otherAlts=" + this.otherAlts + '}';
  }
}
